// BookmarkInfo.cpp : implementation file
//

#include "stdafx.h"
#include "SearchR.h"
#include "BookmarkInfo.h"
#include "BookmarkAdd.h"
#include "TableDoc.h"
#include "MainFrm.h"


// CBookmarkInfo dialog

IMPLEMENT_DYNAMIC(CBookmarkInfo, CDialog)

CBookmarkInfo::CBookmarkInfo(CWnd* pParent /*=NULL*/)
	: CDialog(CBookmarkInfo::IDD, pParent)
{
	ASSERT(pParent != NULL);

	m_pParent = pParent;
	m_nID = CBookmarkInfo::IDD;
}

CBookmarkInfo::~CBookmarkInfo()
{
}

void CBookmarkInfo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_BOOKMARK_LIST, m_bookmark_list);
	DDX_Control(pDX, IDC_BOOKMARK_ADD, m_bookmark_add);
	DDX_Control(pDX, IDC_BOOKMARK_EDIT, m_bookmark_edit);
	DDX_Control(pDX, ID_BOOKMARK_DELETE, m_bookmark_delete);
	DDX_Control(pDX, ID_BOOKMARK_GOTO, m_bookmark_goto);
}


BEGIN_MESSAGE_MAP(CBookmarkInfo, CDialog)
	//{{AFX_MSG_MAP(CBookmarkInfo)
	ON_BN_CLICKED(IDC_BOOKMARK_ADD, OnBnClickedBookmarkAdd)
	ON_BN_CLICKED(IDC_BOOKMARK_EDIT, OnBnClickedBookmarkEdit)
	ON_BN_CLICKED(ID_BOOKMARK_DELETE, OnBnClickedBookmarkDelete)
	ON_BN_CLICKED(ID_BOOKMARK_GOTO, OnBnClickedBookmarkGoto)
	ON_NOTIFY(NM_CLICK, IDC_BOOKMARK_LIST, OnNMClickBookmarkList)
	ON_NOTIFY(NM_DBLCLK, IDC_BOOKMARK_LIST, OnDblclkBookmarkList)
	//}}AFX_MSG_MAP
//	ON_WM_MOVE()
	ON_WM_WINDOWPOSCHANGED()
END_MESSAGE_MAP()


// CBookmarkInfo message handlers

BOOL CBookmarkInfo::Create()
{
	return CDialog::Create(m_nID, m_pParent);
}

BOOL CBookmarkInfo::OnInitDialog()
{
	CDialog::OnInitDialog();

	LOGFONT lf;
	
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight = 10;
	_tcscpy(lf.lfFaceName, _T("Courier"));
	m_font.CreateFontIndirect(&lf);
	m_bookmark_list.SetFont(&m_font);

	m_bookmark_list.InsertColumn(0, _T("Offset"), LVCFMT_LEFT, 88, -1);
	m_bookmark_list.InsertColumn(1, _T("Bookmark"), LVCFMT_LEFT, 128, -1);

	CImageList img2;
	CBitmap arse;

	arse.LoadBitmap(IDB_LIST_BOOKMARK);
	img2.Create(16, 16, ILC_COLOR32 | ILC_MASK, 0, 0);
	img2.Add(&arse, RGB(0, 128, 128));
	m_bookmark_list.SetImageList(&img2, LVSIL_SMALL);
	img2.Detach();
	arse.Detach();

	UpdateList();
	ChangeView();

	if(SearchRConfig::winpos_bookmarks.Width() > 0)
		// restore the old window pos
		MoveWindow(SearchRConfig::winpos_bookmarks, false);
	else
		// centre in the parent window
		CenterWindow(GetParent());

	return TRUE;
}

void CBookmarkInfo::ChangeView(void)
{
	m_bookmark_edit.EnableWindow(m_bookmark_list.GetSelectedCount());
	m_bookmark_delete.EnableWindow(m_bookmark_list.GetSelectedCount());
	m_bookmark_goto.EnableWindow(m_bookmark_list.GetSelectedCount());
}

void CBookmarkInfo::UpdateList(void)
{
	m_bookmark_list.DeleteAllItems();

	CBookmark* curr_bookmark;

	CString str_bookmark;

	DWORD i;
	POSITION pos;

	i = 0;
	pos = p_table_doc->m_bookmark_list.GetHeadPosition();

	while(pos != NULL)
	{
		curr_bookmark = (CBookmark *) p_table_doc->m_bookmark_list.GetAt(pos);

		str_bookmark.Format(_T("%08X"), curr_bookmark->m_offset);
		m_bookmark_list.InsertItem(i, str_bookmark);
		m_bookmark_list.SetItemText(i, 1, curr_bookmark->m_name);
		m_bookmark_list.SetItemData(i, curr_bookmark->m_offset);
		i ++;
		p_table_doc->m_bookmark_list.GetNext(pos);
	}
}

void CBookmarkInfo::OnBnClickedBookmarkAdd()
{
	CBookmarkAdd p_bookmark_add;

	if(p_bookmark_add.DoModal() == IDOK)
	{
		if((p_bookmark_add.m_add_offset.IsEmpty() == FALSE) && (p_bookmark_add.m_add_data.IsEmpty() == FALSE))
		{
			if(p_table_doc)
			{
				DWORD j;
				_stscanf(p_bookmark_add.m_add_offset, _T("%X"), &j);
				p_table_doc->AddBookmark(j, p_bookmark_add.m_add_data);
			}
		}
	}
	p_mainframe->UpdateBookmarks();
	UpdateList();
	ChangeView();
}

void CBookmarkInfo::OnBnClickedBookmarkEdit()
{
	POSITION pos;
	
	pos = m_bookmark_list.GetFirstSelectedItemPosition();
	DWORD i = m_bookmark_list.GetNextSelectedItem(pos);

	CBookmarkAdd p_bookmark_add;

	p_bookmark_add.m_add_offset.Format(_T("%08X"), m_bookmark_list.GetItemData(i));
	p_bookmark_add.m_add_data = m_bookmark_list.GetItemText(i, 1);

	if(p_bookmark_add.DoModal() == IDOK)
	{
		if((p_bookmark_add.m_add_offset.IsEmpty() == FALSE) && (p_bookmark_add.m_add_data.IsEmpty() == FALSE))
		{
			if(p_table_doc)
			{
				p_table_doc->DeleteBookmark(m_bookmark_list.GetItemData(i));
				DWORD j;
				_stscanf(p_bookmark_add.m_add_offset, _T("%X"), &j);
				p_table_doc->AddBookmark(j, p_bookmark_add.m_add_data);
			}
		}
	}
	p_mainframe->UpdateBookmarks();
	UpdateList();
	ChangeView();
}

void CBookmarkInfo::OnBnClickedBookmarkDelete()
{
	POSITION pos;
	
	while(pos = m_bookmark_list.GetFirstSelectedItemPosition())
	{
		int i = m_bookmark_list.GetNextSelectedItem(pos);
		p_table_doc->DeleteBookmark(m_bookmark_list.GetItemData(i));
		m_bookmark_list.DeleteItem(i);
	}
	p_mainframe->UpdateBookmarks();
	UpdateList();
	ChangeView();
}

void CBookmarkInfo::OnBnClickedBookmarkGoto()
{
	POSITION pos;
	
	pos = m_bookmark_list.GetFirstSelectedItemPosition();

	if(pos)
	{
		int i = m_bookmark_list.GetNextSelectedItem(pos);
		p_mainframe->GotoAddress(m_bookmark_list.GetItemData(i));
		ChangeView();
	}
}

void CBookmarkInfo::OnNMClickBookmarkList(NMHDR *pNMHDR, LRESULT *pResult)
{
	ChangeView();
	*pResult = 0;
}

void CBookmarkInfo::OnDblclkBookmarkList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	OnBnClickedBookmarkGoto();
	*pResult = 0;
}

void CBookmarkInfo::OnWindowPosChanged(WINDOWPOS* lpwndpos)
{
	CDialog::OnWindowPosChanged(lpwndpos);
	// store the new window pos
	GetWindowRect(SearchRConfig::winpos_bookmarks);
}
