// GfxTileEdit.cpp : implementation file
//

#include "stdafx.h"
#include "searchr.h"
#include "TableDoc.h"
#include "SearchRDoc.h"
#include "GfxTileEdit.h"
#include "HexEditView.h"
#include "GfxEditView.h"
#include "GfxView.h"
#include "GfxModeAdd.h"

// CGfxTileEdit dialog

IMPLEMENT_DYNAMIC(CGfxTileEdit, CDialog)

CGfxTileEdit::CGfxTileEdit(CWnd* pParent /*=NULL*/)
	: CDialog(CGfxTileEdit::IDD, pParent)
{
	ASSERT(pParent != NULL);

	m_pParent = pParent;
	m_nID = CGfxTileEdit::IDD;
}

CGfxTileEdit::~CGfxTileEdit()
{
}


void CGfxTileEdit::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGfxTileEdit)
	DDX_Control(pDX, IDC_TILE_EDIT, m_tile_edit_ctrl);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGfxTileEdit, CDialog)
	//{{AFX_MSG_MAP(CGfxTileEdit)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_WM_WINDOWPOSCHANGED()
END_MESSAGE_MAP()

// CGfxTileEdit message handlers

BOOL CGfxTileEdit::Create()
{
	return CDialog::Create(m_nID, m_pParent);
}

BOOL CGfxTileEdit::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_tile_edit_ctrl.InitFire(CTileEditCtrl::red);

	m_uTimerID = (UINT)SetTimer(0x451, 33, NULL);

	UpdateList();
	ChangeView();

	if(SearchRConfig::winpos_gfx_tile_edit.Width() > 0)
		// restore the old window pos
		MoveWindow(SearchRConfig::winpos_gfx_tile_edit, false);
	else
	{
		// centre in the parent window
		CRect r_parent, r_child;
		GetParent()->GetWindowRect(r_parent);
		GetWindowRect(r_child);
		MoveWindow(r_parent.right - r_child.Width() - 64, r_parent.top + 128 + 256, r_child.Width(), r_child.Height(), false);
	}

	return TRUE;
}

void CGfxTileEdit::OnTimer(UINT nIDEvent)
{
	CDialog::OnTimer(nIDEvent);

	m_tile_edit_ctrl.PaintFlame();

	// Eat spurious WM_TIMER messages
	MSG msg;
	while(::PeekMessage(&msg, m_hWnd, WM_TIMER, WM_TIMER, PM_REMOVE));
}

void CGfxTileEdit::ChangeView(void)
{
}

void CGfxTileEdit::UpdateList(void)
{
}

void CGfxTileEdit::OnWindowPosChanged(WINDOWPOS* lpwndpos)
{
	CDialog::OnWindowPosChanged(lpwndpos);
	// store the new window pos
	GetWindowRect(SearchRConfig::winpos_gfx_tile_edit);
}
