// GfxView.cpp : implementation file

#include "stdafx.h"
#include "searchr.h"
#include "GfxEditView.h"
#include "GfxView.h"
#include "mainfrm.h"

CGfxView *p_view_4;

// CGfxView

IMPLEMENT_DYNCREATE(CGfxView, CGfxEditView)

CGfxView::CGfxView()
{
	p_view_4 = this;
	gfx_mode_info = NULL;
	gfx_tile_edit = NULL;
}

CGfxView::~CGfxView()
{
}


BEGIN_MESSAGE_MAP(CGfxView, CGfxEditView)
	//{{AFX_MSG_MAP(CGfxView)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CGfxView drawing

void CGfxView::OnDraw(CDC* pDC)
{	
	CGfxEditView::OnDraw(pDC);
}

// CGfxView diagnostics

#ifdef _DEBUG
void CGfxView::AssertValid() const
{
	CGfxEditView::AssertValid();
}

void CGfxView::Dump(CDumpContext& dc) const
{
	CGfxEditView::Dump(dc);
}
#endif //_DEBUG

// CGfxView message handlers

void CGfxView::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CGfxEditView::OnShowWindow(bShow, nStatus);

	if(!gfx_mode_info)
	{
		gfx_mode_info = new CGfxModeInfo(this);
		gfx_mode_info->Create();
	}

	if(!gfx_tile_edit)
	{
		gfx_tile_edit = new CGfxTileEdit(this);
		gfx_tile_edit->Create();
	}

	if(gfx_mode_info)
		if(bShow)
			gfx_mode_info->ShowWindow(SW_SHOW);
		else
			gfx_mode_info->ShowWindow(SW_HIDE);

	if(gfx_tile_edit)
		if(bShow)
			gfx_tile_edit->ShowWindow(SW_SHOW);
		else
			gfx_tile_edit->ShowWindow(SW_HIDE);
}
