// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "SearchR.h"
#include "GfxView.h"
#include "HexView.h"
#include "SearchDialog.h"
#include "SearchResults.h"
#include "SearchRView.h"
#include "TableInfo.h"
#include "TableView.h"
#include "GotoAddress.h"
#include "OptionsSheet.h"
#include "BookmarkAdd.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_VIEW_HEX, OnViewHex)
	ON_COMMAND(ID_VIEW_RELATIVE, OnViewRelative)
	ON_COMMAND(ID_VIEW_TABLE, OnViewTable)
	ON_UPDATE_COMMAND_UI(ID_VIEW_HEX, OnUpdateViewHex)
	ON_UPDATE_COMMAND_UI(ID_VIEW_RELATIVE, OnUpdateViewRelative)
	ON_UPDATE_COMMAND_UI(ID_VIEW_TABLE, OnUpdateViewTable)
	ON_COMMAND(ID_EDIT_SEARCH_NORMAL, OnEditSearchNormal)
	ON_COMMAND(ID_EDIT_SEARCH_RELATIVE, OnEditSearchRelative)
	ON_COMMAND(ID_EDIT_SEARCH_TABLE, OnEditSearchTable)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SEARCH_NORMAL, OnUpdateEditSearchNormal)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SEARCH_RELATIVE, OnUpdateEditSearchRelative)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SEARCH_TABLE, OnUpdateEditSearchTable)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_RESULTS, OnUpdateIndicatorResults)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_FILESIZE, OnUpdateIndicatorFileSize)
	ON_WM_CLOSE()
	ON_COMMAND(ID_TABLE_OPEN, OnTableOpen)
	ON_COMMAND(ID_HELP_CONTENTS, OnHelpContents)
	ON_COMMAND(ID_BOOKMARK_1, GotoBookmark1)
	ON_COMMAND(ID_BOOKMARK_2, GotoBookmark2)
	ON_COMMAND(ID_BOOKMARK_3, GotoBookmark3)
	ON_COMMAND(ID_BOOKMARK_4, GotoBookmark4)
	ON_COMMAND(ID_BOOKMARK_5, GotoBookmark5)
	ON_COMMAND(ID_BOOKMARK_6, GotoBookmark6)
	ON_COMMAND(ID_BOOKMARK_7, GotoBookmark7)
	ON_COMMAND(ID_BOOKMARK_8, GotoBookmark8)
	ON_COMMAND(ID_RECENTTABLES_1, LoadRecentTable1)
	ON_COMMAND(ID_RECENTTABLES_2, LoadRecentTable2)
	ON_COMMAND(ID_RECENTTABLES_3, LoadRecentTable3)
	ON_COMMAND(ID_RECENTTABLES_4, LoadRecentTable4)
	ON_COMMAND(ID_ORGANIZE_BOOKMARKS, OnOrganizeBookmarks)
	ON_WM_INITMENU()
	ON_COMMAND(ID_EDIT_GOTOADDRESS, OnEditGotoaddress)
	ON_UPDATE_COMMAND_UI(ID_EDIT_GOTOADDRESS, OnUpdateEditGotoaddress)
	ON_COMMAND(ID_OPTIONS, OnOptions)
	ON_COMMAND(ID_HELP_FINDER, OnHelpContents)
	ON_COMMAND(ID_HELP, OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, OnHelpFinder)
	ON_COMMAND(ID_VIEW_GFX, OnViewGfx)
	ON_UPDATE_COMMAND_UI(ID_VIEW_GFX, OnUpdateViewGfx)
	ON_COMMAND(ID_BOOKMARK_ADD, OnBookmarkAdd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_FILESIZE,
	ID_INDICATOR_RESULTS,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

CMainFrame *p_mainframe;

// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	p_mainframe = this;

	m_current_view_id = VIEW_HEX;
	m_view_list[VIEW_HEX] = NULL;
	m_view_list[VIEW_RELATIVE] = NULL;
	m_view_list[VIEW_TABLE] = NULL;
	m_view_list[VIEW_GFX] = NULL;
	bookmark_info = NULL;
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndReBar.Create(this))
	{
		TRACE0("Failed to create rebar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() | CBRS_TOOLTIPS | CBRS_FLYBY);
	m_wndToolBar.GetToolBarCtrl().SetButtonWidth(48, 48);
	m_wndToolBar.GetToolBarCtrl().SetExtendedStyle(TBSTYLE_EX_DRAWDDARROWS);

	CImageList img2;
	CBitmap arse;
	CString str;

	arse.LoadBitmap(IDB_OPTIONS_MAIN);
	img2.Create(32, 32, ILC_COLOR32 | ILC_MASK, 0, 0);
	img2.Add(&arse, RGB(0, 128, 128));
	m_wndToolBar.GetToolBarCtrl().SetImageList(&img2);
	img2.Detach();
	arse.Detach();

	m_wndToolBar.ModifyStyle(0, TBSTYLE_FLAT | TBSTYLE_TRANSPARENT);
	m_wndToolBar.SetButtons(NULL, 9);

	str.LoadString(ID_VIEW_HEX);
	m_wndToolBar.SetButtonInfo(0, ID_VIEW_HEX, TBSTYLE_BUTTON, 1);
	m_wndToolBar.SetButtonText(0, str);

	str.LoadString(ID_VIEW_RELATIVE);
	m_wndToolBar.SetButtonInfo(1, ID_VIEW_RELATIVE, TBSTYLE_BUTTON, 2);
	m_wndToolBar.SetButtonText(1, str);

	str.LoadString(ID_VIEW_TABLE);
	m_wndToolBar.SetButtonInfo(2, ID_VIEW_TABLE, TBSTYLE_BUTTON, 0);
	m_wndToolBar.SetButtonText(2, str);

	str.LoadString(ID_VIEW_GFX);
	m_wndToolBar.SetButtonInfo(3, ID_VIEW_GFX, TBSTYLE_BUTTON, 6);
	m_wndToolBar.SetButtonText(3, str);

	m_wndToolBar.SetButtonInfo(4, 0, TBSTYLE_SEP, 0);

	str.LoadString(IDS_OPTIONS);
	m_wndToolBar.SetButtonInfo(5, ID_OPTIONS, TBSTYLE_BUTTON, 5);
	m_wndToolBar.SetButtonText(5, str);

	m_wndToolBar.SetButtonInfo(6, 0, TBSTYLE_SEP, 0);

	str.LoadString(IDS_OPTION_ABOUT);
	m_wndToolBar.SetButtonInfo(7, ID_APP_ABOUT, TBSTYLE_BUTTON, 3);
	m_wndToolBar.SetButtonText(7, str);

	str.LoadString(IDS_OPTION_EXIT);
	m_wndToolBar.SetButtonInfo(8, ID_APP_EXIT, TBSTYLE_BUTTON, 4);
	m_wndToolBar.SetButtonText(8, str);

	CRect rectToolBar;
	m_wndToolBar.GetItemRect(0, &rectToolBar);
	m_wndToolBar.SetSizes(rectToolBar.Size(), CSize(32 + 7, 32));

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_FIXED);

	m_wndReBar.AddBar(&m_wndToolBar);

	//lock_toolbar = FALSE;
	//UpdateBars(TRUE);

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;
	}

	m_current_view_id = VIEW_HEX;
	m_view_list[m_current_view_id] = p_view_1;

	bookmark_info = new CBookmarkInfo(this);
	bookmark_info->Create();
	//if(SearchRConfig::winpos_bookmarks.Width() > 0)
	//	bookmark_info->MoveWindow(SearchRConfig::winpos_bookmarks, false);
	//else
	//	bookmark_info->CenterWindow(this);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;

	return TRUE;
}

void CMainFrame::OnUpdateFrameTitle(BOOL bAddToTitle)
{
	CString str_title;

	if(p_doc->IsModified() == TRUE)
		str_title.Format(_T("SearchR - [%s *]"), p_doc->GetTitle());
	else
		str_title.Format(_T("SearchR - [%s]"), p_doc->GetTitle());

	SetWindowText(str_title);
} 

// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}
#endif //_DEBUG


// CMainFrame message handlers

BOOL CMainFrame::OnViewChange(DWORD view_id)
{
	CBaseView* pViewAdd;
	CBaseView* pViewRemove;

	if (view_id == m_current_view_id)
		return FALSE;

	if ((m_view_list[VIEW_RELATIVE] == NULL) && (view_id == VIEW_RELATIVE))
	{
		m_view_list[VIEW_RELATIVE] = new CSearchRView;
		m_view_list[VIEW_RELATIVE]->Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, rectDefault, this, AFX_IDW_PANE_FIRST + 1, NULL);
	}

	if ((m_view_list[VIEW_TABLE] == NULL) && (view_id == VIEW_TABLE))
	{
		m_view_list[VIEW_TABLE] = new CTableView;
		m_view_list[VIEW_TABLE]->Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, rectDefault, this, AFX_IDW_PANE_FIRST + 1, NULL);
	}

	if ((m_view_list[VIEW_GFX] == NULL) && (view_id == VIEW_GFX))
	{
		m_view_list[VIEW_GFX] = new CGfxView;
		m_view_list[VIEW_GFX]->Create(NULL, NULL, AFX_WS_DEFAULT_VIEW, rectDefault, this, AFX_IDW_PANE_FIRST + 1, NULL);
	}

	pViewAdd = m_view_list[view_id];
	pViewRemove = m_view_list[m_current_view_id];

	m_current_view_id = view_id;

	pViewRemove->StorePosition();
	pViewAdd->RestorePosition();

	int nSwitchChildID = pViewAdd->GetDlgCtrlID();
	pViewAdd->SetDlgCtrlID(AFX_IDW_PANE_FIRST);
	pViewAdd->ShowWindow(SW_SHOW);
	p_doc->AddView(pViewAdd);
	SetActiveView(pViewAdd);
	pViewRemove->SetDlgCtrlID(nSwitchChildID);
	pViewRemove->ShowWindow(SW_HIDE);
	p_doc->RemoveView(pViewRemove);
	RecalcLayout();
	return TRUE;
}

void CMainFrame::OnViewHex()
{
	if(m_current_view_id != VIEW_HEX)
	{
		OnViewChange(VIEW_HEX);
		UpdateCurrentView();
	}
}

void CMainFrame::OnUpdateViewHex(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_current_view_id == VIEW_HEX);
}

void CMainFrame::OnViewRelative()
{
	if(m_current_view_id != VIEW_RELATIVE)
	{
		OnViewChange(VIEW_RELATIVE);
		UpdateCurrentView();
	}
}

void CMainFrame::OnUpdateViewRelative(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_current_view_id == VIEW_RELATIVE);
}

void CMainFrame::OnViewTable()
{
	if(m_current_view_id != VIEW_TABLE)
	{
		OnViewChange(VIEW_TABLE);
		UpdateCurrentView();
	}
}

void CMainFrame::OnUpdateViewTable(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_current_view_id == VIEW_TABLE);
}

void CMainFrame::OnEditSearchNormal()
{
//	CSearchDialog p_dlg;

//	if(p_dlg.DoModal() != IDOK)
//		return;

//	p_doc->DoSearchRelative(p_dlg.m_search_data, +1, 0);

	if(m_current_view_id != VIEW_HEX)
		OnViewChange(VIEW_HEX);

	UpdateCurrentView();
}

void CMainFrame::OnEditSearchRelative()
{
	CSearchDialog p_dlg;

	if(p_dlg.DoModal() != IDOK)
		return;

	p_doc->DoSearchRelative(p_dlg.m_search_data, +1, 0);

	if(m_current_view_id != VIEW_RELATIVE)
		OnViewChange(VIEW_RELATIVE);

	UpdateCurrentView();
}

void CMainFrame::OnEditSearchTable()
{
//	CSearchDialog p_dlg;

//	if(p_dlg.DoModal() != IDOK)
//		return;

//	p_doc->DoSearchRelative(p_dlg.m_search_data, +1, 0);

	if(m_current_view_id != VIEW_TABLE)
		OnViewChange(VIEW_TABLE);

	UpdateCurrentView();
}

void CMainFrame::OnUpdateEditSearchNormal(CCmdUI *pCmdUI)
{
	pCmdUI->Enable((p_doc->data != NULL));
}

void CMainFrame::OnUpdateEditSearchRelative(CCmdUI *pCmdUI)
{
	pCmdUI->Enable((p_doc->data != NULL));
}

void CMainFrame::OnUpdateEditSearchTable(CCmdUI *pCmdUI)
{
	pCmdUI->Enable((p_doc->data != NULL));
}

void CMainFrame::OnUpdateIndicatorResults(CCmdUI *pCmdUI)
{
    pCmdUI->Enable(); 
    CString str;
	str.Format( _T("Results: %d"), p_doc->result_count); 
    pCmdUI->SetText(str); 
}

void CMainFrame::OnUpdateIndicatorFileSize(CCmdUI *pCmdUI)
{
    pCmdUI->Enable(); 
    CString str;
	str.Format( _T("File Size: 0x%08X"), p_doc->size); 
    pCmdUI->SetText(str); 
}

void CMainFrame::UpdateCurrentView()
{
	bookmark_info->UpdateList();
	bookmark_info->ChangeView();

	m_view_list[m_current_view_id]->ChangeView();
}

void CMainFrame::OnClose()
{
	if(!p_table_doc->SaveTable())
		return;

	CFrameWnd::OnClose();
}

void CMainFrame::OnTableOpen()
{
	p_table_doc->LoadTable();
}

void CMainFrame::OnHelpContents() 
{
#ifdef WINDOWS_XP_BUILD
	CFrameWnd::OnHelpFinder();
#else
	HWND hwnd = ::HtmlHelp(NULL, _T("SearchR.chm::/Introduction.htm"), HH_DISPLAY_TOPIC, 0);	
#endif
}

void CMainFrame::UpdateTableList(void)
{
	// Locate the submenu
	CMenu* pColorMenu = NULL;
	CMenu* pTopMenu = AfxGetMainWnd()->GetMenu();
	int iPos;
	for (iPos = pTopMenu->GetMenuItemCount()-1; iPos >= 0; iPos--)
	{
		CMenu* pMenu = pTopMenu->GetSubMenu(iPos);
		if (pMenu && pMenu->GetMenuItemID(0) == ID_TABLE_OPEN)
		{
			pColorMenu = pMenu;
			break;
		}
	}
	ASSERT(pColorMenu != NULL);

	pColorMenu = pColorMenu->GetSubMenu(7);
	ASSERT(pColorMenu != NULL);

	// Update the color submenu to reflect the text colors available to
	// the active document

	// First, delete all items but ID_COLOR_OPTIONS at position 0
	for (iPos = pColorMenu->GetMenuItemCount()-1; iPos >= 0; iPos--)
		pColorMenu->DeleteMenu(iPos, MF_BYPOSITION);

	DWORD i, j;

	j = 1;
	for(i = 0; i < SearchRConfig::TABLE_MRU_SIZE; i ++)
	{
		if(SearchRConfig::table_mru_list[i].IsEmpty() == FALSE)
		{
			CString str_bookmark;
			str_bookmark.Format(_T("%d %s"), j++, SearchRConfig::table_mru_list[i]);
			pColorMenu->AppendMenu(MF_STRING, ID_RECENTTABLES_1 + i, str_bookmark);
		}
	}
}

void CMainFrame::UpdateBookmarks(void)
{
	// Locate the submenu
	CMenu* pColorMenu = NULL;
	CMenu* pTopMenu = AfxGetMainWnd()->GetMenu();
	int iPos;
	for (iPos = pTopMenu->GetMenuItemCount()-1; iPos >= 0; iPos--)
	{
		CMenu* pMenu = pTopMenu->GetSubMenu(iPos);
		if (pMenu && pMenu->GetMenuItemID(0) == ID_TABLE_OPEN)
		{
			pColorMenu = pMenu;
			break;
		}
	}
	ASSERT(pColorMenu != NULL);

	pColorMenu = pColorMenu->GetSubMenu(5);
	ASSERT(pColorMenu != NULL);

	// Update the color submenu to reflect the text colors available to
	// the active document

	// First, delete all items but the first 2
	for (iPos = pColorMenu->GetMenuItemCount()-1; iPos > 1; iPos--)
		pColorMenu->DeleteMenu(iPos, MF_BYPOSITION);

	// Then, add a separator and an item for each available text color
	BOOL bNeedSeparator = TRUE;

	if(!p_table_doc)
		return;

	CBookmark* curr_bookmark;

	CString str_bookmark;

	DWORD i;	
	POSITION pos;

	i = 0;
	pos = p_table_doc->m_bookmark_list.GetHeadPosition();

	while(pos != NULL)
	{
		if (bNeedSeparator)
		{
			pColorMenu->AppendMenu(MF_SEPARATOR);
			bNeedSeparator = FALSE;
		}

		curr_bookmark = (CBookmark *) p_table_doc->m_bookmark_list.GetAt(pos);

		str_bookmark.Format(_T("0x%08X: %s"), curr_bookmark->m_offset, curr_bookmark->m_name);
		pColorMenu->AppendMenu(MF_STRING, ID_BOOKMARK_1 + i, str_bookmark);

		i ++;
		p_table_doc->m_bookmark_list.GetNext(pos);
	}

}

void CMainFrame::GotoBookmark(DWORD i)
{
	if(!p_table_doc)
		return;

	POSITION pos;

	pos = p_table_doc->m_bookmark_list.GetHeadPosition();

	while((i > 1) && (pos != NULL))
	{
		i --;
		p_table_doc->m_bookmark_list.GetNext(pos);
	}

	if(pos == NULL)
		return;

	GotoBookmark((CBookmark *) p_table_doc->m_bookmark_list.GetAt(pos));
}

void CMainFrame::GotoBookmark(CBookmark *bookmark)
{
	m_view_list[m_current_view_id]->JumpToSelected(bookmark->m_offset, bookmark->m_offset);
}

void CMainFrame::GotoAddress(DWORD offset)
{
	m_view_list[m_current_view_id]->JumpToSelected(offset, offset);
}

void CMainFrame::GotoBookmark1(void)
{
	GotoBookmark(1);
}

void CMainFrame::GotoBookmark2(void)
{
	GotoBookmark(2);
}

void CMainFrame::GotoBookmark3(void)
{
	GotoBookmark(3);
}

void CMainFrame::GotoBookmark4(void)
{
	GotoBookmark(4);
}

void CMainFrame::GotoBookmark5(void)
{
	GotoBookmark(5);
}

void CMainFrame::GotoBookmark6(void)
{
	GotoBookmark(6);
}

void CMainFrame::GotoBookmark7(void)
{
	GotoBookmark(7);
}

void CMainFrame::GotoBookmark8(void)
{
	GotoBookmark(8);
}

void CMainFrame::OnInitMenu(CMenu* pMenu)
{
	CFrameWnd::OnInitMenu(pMenu);

	UpdateTableList();
}

void CMainFrame::LoadRecentTable(DWORD i)
{
	_TCHAR fname[_MAX_FNAME];
	_TCHAR ext[_MAX_EXT];
	CString file_name;

	i --;

	_tsplitpath(SearchRConfig::table_mru_list[i], NULL, NULL, fname, ext);

	file_name = fname;
	file_name += ext;

	p_table_doc->DoLoadTable(SearchRConfig::table_mru_list[i], file_name);
}

void CMainFrame::LoadRecentTable1(void)
{
	LoadRecentTable(1);
}

void CMainFrame::LoadRecentTable2(void)
{
	LoadRecentTable(2);
}

void CMainFrame::LoadRecentTable3(void)
{
	LoadRecentTable(3);
}

void CMainFrame::LoadRecentTable4(void)
{
	LoadRecentTable(4);
}


void CMainFrame::OnEditGotoaddress()
{
	CGotoAddress p_dlg;

	if(p_dlg.DoModal() != IDOK)
		return;

	DWORD i;
	_stscanf(p_dlg.m_address, _T("%X"), &i);

	GotoAddress(i);
}

void CMainFrame::OnUpdateEditGotoaddress(CCmdUI *pCmdUI)
{
	pCmdUI->Enable((p_doc->data != NULL));
}

void CMainFrame::OnOrganizeBookmarks() 
{
	if(bookmark_info)
		bookmark_info->ShowWindow(SW_SHOW);
}

void CMainFrame::OnOptions()
{
	COptionsSheet p_options_sheet(_T("Options"));

	if (p_options_sheet.DoModal() != IDOK)
		return;

	UpdateCurrentView();
}

void CMainFrame::OnViewGfx() 
{
	if(m_current_view_id != VIEW_GFX)
	{
		OnViewChange(VIEW_GFX);
		UpdateCurrentView();
	}
}

void CMainFrame::OnUpdateViewGfx(CCmdUI *pCmdUI)
{
	pCmdUI->SetRadio(m_current_view_id == VIEW_GFX);
}

void CMainFrame::OnBookmarkAdd()
{
	CBookmarkAdd p_bookmark_add;

	if(p_bookmark_add.DoModal() == IDOK)
	{
		if((p_bookmark_add.m_add_offset.IsEmpty() == FALSE) && (p_bookmark_add.m_add_data.IsEmpty() == FALSE))
		{
			if(p_table_doc)
			{
				DWORD j;
				_stscanf(p_bookmark_add.m_add_offset, _T("%X"), &j);
				p_table_doc->AddBookmark(j, p_bookmark_add.m_add_data);
			}
		}
	}
	UpdateBookmarks();
	UpdateCurrentView();
}
