// MainFrm.h : interface of the CMainFrame class
//
#pragma once

#include "HexEditView.h"
#include "GfxEditView.h"
#include "BookmarkInfo.h"
#include "SearchRDoc.h"

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

// Operations
public:

// Overrides
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	enum VIEW_ID
	{
		VIEW_HEX,
		VIEW_RELATIVE,
		VIEW_TABLE,
		VIEW_GFX,
		VIEW_COUNT,
	};

protected:  // control bar embedded members
	BOOL OnViewChange(DWORD view_id);

	DWORD m_current_view_id;
	CBaseView *m_view_list[VIEW_COUNT];

	CStatusBar m_wndStatusBar;
	CToolBar m_wndToolBar;
	CReBar m_wndReBar;
	CBookmarkInfo *bookmark_info;

public:
	void UpdateCurrentView(void);
	void UpdateTableList(void);
	void UpdateBookmarks(void);
	void GotoBookmark(DWORD i);
	void GotoBookmark(CBookmark *bookmark);
	void GotoAddress(DWORD offset);
	void LoadRecentTable(DWORD i);
	void OnUpdateFrameTitle(BOOL bAddToTitle);

	// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnViewHex();
	afx_msg void OnViewRelative();
	afx_msg void OnViewTable();
	afx_msg void OnUpdateViewHex(CCmdUI *pCmdUI);
	afx_msg void OnUpdateViewRelative(CCmdUI *pCmdUI);
	afx_msg void OnUpdateViewTable(CCmdUI *pCmdUI);
	afx_msg void OnEditSearchNormal();
	afx_msg void OnEditSearchRelative();
	afx_msg void OnEditSearchTable();
	afx_msg void OnUpdateEditSearchNormal(CCmdUI *pCmdUI);
	afx_msg void OnUpdateEditSearchRelative(CCmdUI *pCmdUI);
	afx_msg void OnUpdateEditSearchTable(CCmdUI *pCmdUI);
	afx_msg void OnUpdateIndicatorResults(CCmdUI *pCmdUI);
	afx_msg void OnUpdateIndicatorFileSize(CCmdUI *pCmdUI);
	afx_msg void OnClose();
	afx_msg void OnTableOpen();
	afx_msg void OnHelpContents();
	afx_msg void GotoBookmark1();
	afx_msg void GotoBookmark2();
	afx_msg void GotoBookmark3();
	afx_msg void GotoBookmark4();
	afx_msg void GotoBookmark5();
	afx_msg void GotoBookmark6();
	afx_msg void GotoBookmark7();
	afx_msg void GotoBookmark8();
	afx_msg void LoadRecentTable1();
	afx_msg void LoadRecentTable2();
	afx_msg void LoadRecentTable3();
	afx_msg void LoadRecentTable4();
	afx_msg void OnOrganizeBookmarks();
	afx_msg void OnInitMenu(CMenu* pMenu);
	afx_msg void OnEditGotoaddress();
	afx_msg void OnUpdateEditGotoaddress(CCmdUI *pCmdUI);
	afx_msg void OnOptions();
	afx_msg void OnViewGfx();
	afx_msg void OnUpdateViewGfx(CCmdUI* pCmdUI);
	afx_msg void OnBookmarkAdd();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
};

extern CMainFrame *p_mainframe;

