// OptionsDisplay.cpp : implementation file
//

#include "stdafx.h"
#include "searchr.h"
#include "OptionsDisplay.h"


IMPLEMENT_DYNAMIC(CColorButton, CButton)

BEGIN_MESSAGE_MAP(CColorButton, CButton)
	//{{AFX_MSG_MAP(CColorButton)
	ON_CONTROL_REFLECT(BN_CLICKED, OnClicked)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

COLORREF custom_colours[16];

void CColorButton::OnClicked() 
{
	CHOOSECOLOR	cc;

	ZeroMemory(&cc, sizeof(CHOOSECOLOR));
	cc.lStructSize = sizeof(CHOOSECOLOR);
	cc.hwndOwner = GetOwner()->m_hWnd;
	cc.lpCustColors = custom_colours;
	cc.rgbResult = m_color;
	cc.Flags = CC_SOLIDCOLOR | CC_FULLOPEN | CC_RGBINIT;

	if(!ChooseColor(&cc))
		return;

	m_color = cc.rgbResult;	
	RedrawWindow();
}

void CColorButton::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct) 
{	
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);

	CRect btnRect;
	btnRect.CopyRect(&lpDrawItemStruct->rcItem);

	CPen newPen;
	CPen *oldPen;
	if(lpDrawItemStruct->itemState & ODS_SELECTED)
		newPen.CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW));
	else
		newPen.CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT));
	oldPen = pDC->SelectObject(&newPen);
	pDC->MoveTo(btnRect.left  + 0, btnRect.bottom - 1);
	pDC->LineTo(btnRect.left  + 0, btnRect.top    + 0);
	pDC->MoveTo(btnRect.left  + 0, btnRect.top    + 0);
	pDC->LineTo(btnRect.right - 1, btnRect.top    + 0);
	pDC->SelectObject(oldPen);
    newPen.DeleteObject();
	if(lpDrawItemStruct->itemState & ODS_SELECTED)
		newPen.CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNHIGHLIGHT));
	else
		newPen.CreatePen(PS_SOLID, 1, GetSysColor(COLOR_BTNSHADOW));
	oldPen = pDC->SelectObject(&newPen);
	pDC->MoveTo(btnRect.left  + 0, btnRect.bottom - 1);
	pDC->LineTo(btnRect.right - 1, btnRect.bottom - 1);
	pDC->MoveTo(btnRect.right - 1, btnRect.bottom - 1);
	pDC->LineTo(btnRect.right - 1, btnRect.top    + 0);
	pDC->SelectObject(oldPen);
    newPen.DeleteObject();

	CBrush B;
	B.CreateSolidBrush(m_color);
	btnRect.left += 4;
	btnRect.right -= 4;
	btnRect.top += 4;
	btnRect.bottom -= 4;
	pDC->FillRect(&btnRect, &B);
}

void CColorButton::SetColor(COLORREF c)
{
	m_color = c;
	RedrawWindow();
}

COLORREF CColorButton::GetColor(void)
{
	return m_color;
}

/////////////////////////////////////////////////////////////////////////////
// COptionsDisplay property page

IMPLEMENT_DYNCREATE(COptionsDisplay, CPropertyPage)

COptionsDisplay::COptionsDisplay() : CPropertyPage(COptionsDisplay::IDD)
{
	//{{AFX_DATA_INIT(COptionsDisplay)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

COptionsDisplay::~COptionsDisplay()
{
}

void COptionsDisplay::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COptionsDisplay)
	DDX_Control(pDX, IDC_COLOUR_0, m_colour_0);
	DDX_Control(pDX, IDC_COLOUR_1, m_colour_1);
	DDX_Control(pDX, IDC_COLOUR_2, m_colour_2);
	DDX_Control(pDX, IDC_COLOUR_3, m_colour_3);
	DDX_Control(pDX, IDC_COLOUR_4, m_colour_4);
	DDX_Control(pDX, IDC_COLOUR_5, m_colour_5);
	DDX_Control(pDX, IDC_COLOUR_6, m_colour_6);
	DDX_Control(pDX, IDC_COLOUR_7, m_colour_7);
	DDX_Control(pDX, IDC_COLOUR_8, m_colour_8);
	DDX_Control(pDX, IDC_COLOUR_9, m_colour_9);
	DDX_Control(pDX, IDC_COLOUR_10, m_colour_10);
	DDX_Control(pDX, IDC_COLOUR_11, m_colour_11);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COptionsDisplay, CPropertyPage)
	//{{AFX_MSG_MAP(COptionsDisplay)
	ON_BN_CLICKED(IDC_DEFAULT_COLOURS, OnBnClickedDefaultColours)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsDisplay message handlers

BOOL COptionsDisplay::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	m_colour_0.SetColor(SearchRConfig::hex_view_colour_data[0][0]);
	m_colour_1.SetColor(SearchRConfig::hex_view_colour_data[0][1]);
	m_colour_2.SetColor(SearchRConfig::hex_view_colour_data[0][2]);
	m_colour_3.SetColor(SearchRConfig::hex_view_colour_data[0][3]);
	m_colour_4.SetColor(SearchRConfig::hex_view_colour_data[0][4]);
	m_colour_5.SetColor(SearchRConfig::hex_view_colour_data[0][5]);
	m_colour_6.SetColor(SearchRConfig::hex_view_colour_data[0][6]);
	m_colour_7.SetColor(SearchRConfig::hex_view_colour_data[0][7]);
	m_colour_8.SetColor(SearchRConfig::hex_view_colour_data[0][8]);
	m_colour_9.SetColor(SearchRConfig::hex_view_colour_data[0][9]);
	m_colour_10.SetColor(SearchRConfig::hex_view_colour_data[1][0]);
	m_colour_11.SetColor(SearchRConfig::hex_view_colour_data[2][0]);


	return TRUE;
}

void COptionsDisplay::OnOK()
{
	SearchRConfig::hex_view_colour_data[0][0] = m_colour_0.GetColor();
	SearchRConfig::hex_view_colour_data[0][1] = m_colour_1.GetColor();
	SearchRConfig::hex_view_colour_data[0][2] = m_colour_2.GetColor();
	SearchRConfig::hex_view_colour_data[0][3] = m_colour_3.GetColor();
	SearchRConfig::hex_view_colour_data[0][4] = m_colour_4.GetColor();
	SearchRConfig::hex_view_colour_data[0][5] = m_colour_5.GetColor();
	SearchRConfig::hex_view_colour_data[0][6] = m_colour_6.GetColor();
	SearchRConfig::hex_view_colour_data[0][7] = m_colour_7.GetColor();
	SearchRConfig::hex_view_colour_data[0][8] = m_colour_8.GetColor();
	SearchRConfig::hex_view_colour_data[0][9] = m_colour_9.GetColor();
	SearchRConfig::hex_view_colour_data[1][0] = m_colour_10.GetColor();
	SearchRConfig::hex_view_colour_data[2][0] = m_colour_11.GetColor();

	CPropertyPage::OnOK();
}

void COptionsDisplay::OnBnClickedDefaultColours()
{
	m_colour_0.SetColor(hex_edit_def_colours[0]);
	m_colour_1.SetColor(hex_edit_def_colours[1]);
	m_colour_2.SetColor(hex_edit_def_colours[2]);
	m_colour_3.SetColor(hex_edit_def_colours[3]);
	m_colour_4.SetColor(hex_edit_def_colours[4]);
	m_colour_5.SetColor(hex_edit_def_colours[5]);
	m_colour_6.SetColor(hex_edit_def_colours[6]);
	m_colour_7.SetColor(hex_edit_def_colours[7]);
	m_colour_8.SetColor(hex_edit_def_colours[8]);
	m_colour_9.SetColor(hex_edit_def_colours[9]);
	m_colour_10.SetColor(RGB(0xFF, 0xFF, 0xF0));
	m_colour_11.SetColor(RGB(0xF7, 0xF7, 0xFF));
}
