// SearchDialog.cpp : implementation file
//

#include "stdafx.h"
#include "SearchR.h"
#include "SearchDialog.h"


// CSearchDialog dialog

IMPLEMENT_DYNAMIC(CSearchDialog, CDialog)

CSearchDialog::CSearchDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CSearchDialog::IDD, pParent)
	, m_search_data(_T(""))
	, m_next_char_offset(0)
	, m_next_char(0)
{
}

CSearchDialog::~CSearchDialog()
{
}

void CSearchDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_SEARCH_DATA, m_search_data);
	DDV_MaxChars(pDX, m_search_data, 16);
	DDX_Control(pDX, IDC_COMBO_NEXT_CHAR_OFFSET, m_combo_next_char_offset);
	DDX_Control(pDX, IDC_COMBO_SEQUENCE_ORDER, m_combo_sequence_order);
	DDX_CBIndex(pDX, IDC_COMBO_NEXT_CHAR_OFFSET, m_next_char_offset);
	DDX_Control(pDX, IDC_SEARCH_DATA, m_combo_search_data);
}


BEGIN_MESSAGE_MAP(CSearchDialog, CDialog)
	//{{AFX_MSG_MAP(CSearchDialog)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CSearchDialog message handlers

BOOL CSearchDialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	UpdateData(TRUE);
	m_combo_next_char_offset.AddString(_T("-2"));
	m_combo_next_char_offset.AddString(_T("-1"));
	m_combo_next_char_offset.AddString(_T("+1 (default)"));
	m_combo_next_char_offset.AddString(_T("+2"));
	m_combo_next_char_offset.SetItemData(0, -2);
	m_combo_next_char_offset.SetItemData(1, -1);
	m_combo_next_char_offset.SetItemData(2, +1);
	m_combo_next_char_offset.SetItemData(3, +2);

	m_next_char_offset = 2;
	m_combo_next_char_offset.SetCurSel(m_next_char_offset);

	m_combo_sequence_order.AddString(_T("Any Order (default)"));
	m_combo_sequence_order.AddString(_T("abc, ABC, 123"));
	m_combo_sequence_order.AddString(_T("abc, 123, ABC"));
	m_combo_sequence_order.AddString(_T("ABC, abc, 123"));
	m_combo_sequence_order.AddString(_T("ABC, 123, abc"));
	m_combo_sequence_order.AddString(_T("123, abc, ABC"));
	m_combo_sequence_order.AddString(_T("123, ABC, abc"));
	m_combo_sequence_order.SetCurSel(0);

	DWORD i;

	for(i = 0; i < SearchRConfig::SEARCH_HISTORY; i ++)
	{
		if(SearchRConfig::search_string[i].IsEmpty() == FALSE)
			m_combo_search_data.AddString(SearchRConfig::search_string[i]);
	}

	UpdateData(FALSE);

	return TRUE;
}

void CSearchDialog::OnOK()
{
	UpdateData(TRUE);
	m_next_char = (DWORD) m_combo_next_char_offset.GetItemData(m_next_char_offset);

	if(m_search_data.IsEmpty() == FALSE)
	{
		CString s[SearchRConfig::SEARCH_HISTORY];
		DWORD i, j;

		for(i = 0; i < SearchRConfig::SEARCH_HISTORY; i ++)
			s[i] = SearchRConfig::search_string[i];

		SearchRConfig::search_string[0] = m_search_data;

		for(i = 0, j = 1; (i < SearchRConfig::SEARCH_HISTORY) && (j < SearchRConfig::SEARCH_HISTORY); i ++)
		{
			if(s[i] != m_search_data)
				if(s[i].IsEmpty() == FALSE)
					SearchRConfig::search_string[j++] = s[i];
		}
		while(j < SearchRConfig::SEARCH_HISTORY)
			SearchRConfig::search_string[j++] = "";
	}

	UpdateData(FALSE);

	CDialog::OnOK();
}
