// SearchRView.cpp : implementation file
//

#include "stdafx.h"
#include "searchr.h"
#include "SearchRDoc.h"
#include "HexEditView.h"
#include "SearchRView.h"
#include "mainfrm.h"

CSearchRView *p_view_2;

/////////////////////////////////////////////////////////////////////////////
// CSearchRView

IMPLEMENT_DYNCREATE(CSearchRView, CHexEditView)

CSearchRView::CSearchRView()
{
	p_view_2 = this;
	results_dialog = NULL;
	result_data = NULL;
	for(int i = 0; i < CHexEditView::COLOUR_COUNT; i ++)
		SetColour(SearchRConfig::hex_view_colour_data[0][i], i);
	SetColour(SearchRConfig::hex_view_colour_data[1][BACK_COLOUR], BACK_COLOUR);
}

CSearchRView::~CSearchRView()
{
}


BEGIN_MESSAGE_MAP(CSearchRView, CHexEditView)
	//{{AFX_MSG_MAP(CSearchRView)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSearchRView drawing

void CSearchRView::OnDraw(CDC* pDC)
{	
	CHexEditView::OnDraw(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CSearchRView diagnostics

#ifdef _DEBUG
void CSearchRView::AssertValid() const
{
	CHexEditView::AssertValid();
}

void CSearchRView::Dump(CDumpContext& dc) const
{
	CHexEditView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CSearchRView message handlers

void CSearchRView::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CHexEditView::OnShowWindow(bShow, nStatus);
	
	if(!results_dialog)
	{
		results_dialog = new CSearchResults(this);
		results_dialog->Create();
	}

	if(results_dialog)
		if(bShow)
			results_dialog->ShowWindow(SW_SHOW);
		else
			results_dialog->ShowWindow(SW_HIDE);
}

BOOL CSearchRView::MakeString(DWORD i, CString& s, BYTE bytes)
{
	if(bytes == 1)
	{
		if((result_data != NULL) && (result_data->lookup_valid[i] == TRUE) && (_istprint(result_data->lookup[i]) != 0))
		{
			s = (_TCHAR) result_data->lookup[i];
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CSearchRView::MakeHex(CString s, DWORD &i, BYTE bytes)
{
	if(bytes == 1)
	{
		if(result_data != NULL)
			for(int j = 0; j < 0x100; j ++)
				if(result_data->lookup_valid[j] == TRUE)
					if(result_data->lookup[j] == s[0])
					{
						i = j;
						return TRUE;
					}
	}
	return FALSE;
}

void CSearchRView::ViewResult()
{
	if(!result_data)
		return;

	JumpToSelected(result_data->offset, result_data->offset + result_data->length - 1);
}

void CSearchRView::ChangeView()
{
	for(int i = 0; i < CHexEditView::COLOUR_COUNT; i ++)
		SetColour(SearchRConfig::hex_view_colour_data[0][i], i);
	SetColour(SearchRConfig::hex_view_colour_data[1][BACK_COLOUR], BACK_COLOUR);

	CHexEditView::ChangeView();

	//results_dialog->ClearResults();
	results_dialog->ChangeView();
}
