#pragma once

// CBookmark object

class CBookmark : public CObject
{
public:
	DWORD m_offset;
	CString m_name;
	CBookmark()
	{
		m_offset = 0;
		m_name.Empty();
	}
	CBookmark(DWORD offset, LPCTSTR name)
	{
		m_offset = offset;
		m_name = name;
	}
	CBookmark( const CBookmark& a )
	{
		m_offset = a.m_offset;
		m_name = a.m_name;
	}
	const CBookmark& operator=( const CBookmark& a )
	{
		m_offset = a.m_offset;
		m_name = a.m_name;
		return *this;
	}
	BOOL operator==(CBookmark a)
	{
		return m_offset == a.m_offset;
	}
#ifdef _DEBUG
	void Dump( CDumpContext& dc ) const
	{
		CObject::Dump( dc );
		dc << m_offset;
	}
#endif
};

// CTableDoc document

class CTableDoc : public CDocument
{
	DECLARE_DYNCREATE(CTableDoc)

public:
	CTableDoc();
	virtual ~CTableDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual BOOL OnNewDocument();

public:

	enum TABLE_DATA
	{
		MAX_TABLE_SIZE = 0x10000,
	};
	BYTE table_data_reverse[MAX_TABLE_SIZE];
	BOOL table_valid[MAX_TABLE_SIZE];
	CString table_data_mte[MAX_TABLE_SIZE];
	BOOL SaveTable(void);
	void LoadTable(void);
	void AddToTable(DWORD offset, _TCHAR data);
	void AddToTable(DWORD offset, LPCTSTR data);
	void DeleteFromTable(DWORD offset);
	void DoLoadTable(LPCTSTR file_name, LPCTSTR file_title);
	void AddBookmark(DWORD offset, LPCTSTR name);
	void DeleteBookmark(DWORD offset);

	CString filename;
	CObList m_bookmark_list;

	DECLARE_MESSAGE_MAP()
};

extern CTableDoc *p_table_doc;
