// TableView.cpp : implementation file
//

#include "stdafx.h"
#include "SearchR.h"
#include "TableDoc.h"
#include "SearchRDoc.h"
#include "TableDoc.h"
#include "TableInfo.h"
#include "BookmarkInfo.h"
#include "HexEditView.h"
#include "TableView.h"
#include "mainfrm.h"

CTableView *p_view_3;

/////////////////////////////////////////////////////////////////////////////
// CTableView

IMPLEMENT_DYNCREATE(CTableView, CHexEditView)

CTableView::CTableView()
{
	p_view_3 = this;
	table_info = NULL;
	for(int i = 0; i < CHexEditView::COLOUR_COUNT; i ++)
		SetColour(SearchRConfig::hex_view_colour_data[0][i], i);
	SetColour(SearchRConfig::hex_view_colour_data[2][BACK_COLOUR], BACK_COLOUR);
}

CTableView::~CTableView()
{
}


BEGIN_MESSAGE_MAP(CTableView, CHexEditView)
	//{{AFX_MSG_MAP(CTableView)
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTableView drawing

void CTableView::OnDraw(CDC* pDC)
{
	CHexEditView::OnDraw(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CTableView diagnostics

#ifdef _DEBUG
void CTableView::AssertValid() const
{
	CHexEditView::AssertValid();
}

void CTableView::Dump(CDumpContext& dc) const
{
	CHexEditView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTableView message handlers

/*DWORD CTableView::MakeByte(_TCHAR i)
{
	if(!p_table_doc)
		return '.';

	return p_table_doc->table_data_reverse[i];
}*/

BOOL CTableView::MakeString(DWORD i, CString& s, BYTE bytes)
{
	if(bytes == 1)
	{
		if(p_table_doc->table_valid[i])
		{
			s = p_table_doc->table_data_mte[i];
			return TRUE;
		}
	}
	else
	{
		if((p_table_doc->table_valid[i]) && (i >= 0x100)) // hack?
		{
			s = p_table_doc->table_data_mte[i];
			return TRUE;
		}
	}
	return FALSE;
}

BOOL CTableView::MakeHex(CString s, DWORD &i, BYTE bytes)
{
	if(bytes == 1)
	{
		if(p_table_doc != NULL)
			for(int j = 0; j < 0x10000; j ++)
				if(p_table_doc->table_valid[j] == TRUE)
					if(p_table_doc->table_data_mte[j] == s)
					{
						i = j;
						return TRUE;
					}
	}
	return FALSE;
}

void CTableView::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CHexEditView::OnShowWindow(bShow, nStatus);
	
	if(!table_info)
	{
		table_info = new CTableInfo(this);
		table_info->Create();
	}

	if(table_info)
		if(bShow)
			table_info->ShowWindow(SW_SHOW);
		else
			table_info->ShowWindow(SW_HIDE);
}

void CTableView::ChangeView()
{
	for(int i = 0; i < CHexEditView::COLOUR_COUNT; i ++)
		SetColour(SearchRConfig::hex_view_colour_data[0][i], i);
	SetColour(SearchRConfig::hex_view_colour_data[2][BACK_COLOUR], BACK_COLOUR);

	CHexEditView::ChangeView();

	table_info->UpdateList();
	table_info->ChangeView();
}